<script>
import Vue from 'vue';
import {
  SlpContainer,
  SlpTooltip,
  OneTrustTroubleWarning,
} from '../common/index.vue';

export default Vue.extend({
  name: 'FreeTrialPlans',
  components: {
    OneTrustTroubleWarning,
    SlpTooltip,
    SlpContainer,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      tabs: {
        saas: 'sass',
        self_managed: 'self-managed',
      },
      selectedTab: '',
      submitted: false,
      cnbc_clicked: false,
    };
  },
  beforeMount() {
    this.selectedTab = this.tabs.saas;
  },
  mounted() {
    this.refreshForm();
  },
  methods: {
    onTabSelection(tabId) {
      this.selectedTab = tabId;
      this.refreshForm();
    },
    refreshForm() {
      window.MktoForms2.setOptions({
        formXDPath: '/rs/194-VVC-221/images/marketo-xdframe-relative.html',
      });
      window.MktoForms2.loadForm(
        '//page.gitlab.com',
        '194-VVC-221',
        this.data.self_managed.form_id,
        (form) => {
          form.onSuccess(() => {
            this.$emit('submit');
            this.submitted = true;
            // eslint-disable-next-line no-undef
            dataLayer.push({
              event: 'trial',
              mktoFormId: form.getId(),
              eventCallback() {
                form.getFormElem().hide();
              },
              eventTimeout: 3000,
            });
            return false;
          });

          function getgacid() {
            try {
              const tracker = ga.getAll()[0]; // eslint-disable-line no-undef
              return tracker.get('clientId');
            } catch (e) {
              return 'n/a';
            }
          }

          form.vals({
            gacid: getgacid(),
          });
        },
      );
    },
  },
});
</script>

<template>
  <section class="slp-mb-96">
    <script src="//page.gitlab.com/js/forms2/js/forms2.min.js"></script>
    <SlpContainer>
      <div class="plans">
        <div>
          <a
            class="plans__link"
            :class="{ 'plans__link--active': selectedTab === tabs.saas }"
            @click="onTabSelection(tabs.saas)"
          >
            GitLab
            <SlpTooltip :text="data.saas.tooltip_text">
              <span>SaaS</span>
            </SlpTooltip>
          </a>
          <a
            class="plans__link"
            :class="{
              'plans__link--active': selectedTab === tabs.self_managed,
            }"
            @click="onTabSelection(tabs.self_managed)"
          >
            GitLab Self-Managed
          </a>
        </div>
        <div class="plans__content">
          <div v-show="selectedTab === tabs.saas">
            <p class="plans__text">{{ data.saas.text }}</p>
            <div class="slp-flex slp-flex-column">
              <slp-button
                :href="data.saas.link.href"
                class="slp-mb-16"
                :data-ga-name="data.saas.link.data_ga_name"
                :data-ga-location="data.saas.link.data_ga_location"
              >
                {{ data.saas.link.text }}
              </slp-button>
              <div
                v-if="data.saas.bottom_text"
                v-html="$md.render(data.saas.bottom_text)"
              ></div>
            </div>
          </div>
          <div v-if="selectedTab === tabs.self_managed">
            <p class="plans__text">{{ data.self_managed.form_header }}</p>
            <form
              v-if="!submitted"
              :id="`mktoForm_${data.self_managed.form_id}`"
              class="mktoForm_container"
            />
            <div v-else>
              <p>
                Thanks for signing up for your free trial! You will get
                additional instructions in your inbox shortly.
              </p>
            </div>
            <OneTrustTroubleWarning />
          </div>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.plans {
  max-width: 540px;
  margin: 0 auto;
  overflow: hidden;
  display: flex;
  flex-direction: column;

  &__link {
    width: 50%;
    color: #333;
    font-size: 15px;
    text-align: center;
    float: left;
    outline: 0;
    cursor: pointer;
    padding: 10px 6px;
    transition: 0.3s;
    border-bottom: 1px solid #333;

    @media (min-width: $breakpoint-sm) {
      font-size: 23px;
      padding: 14px 16px;
    }

    &--active {
      border: 1px solid #333;
      border-bottom: none;
      border-top-left-radius: 4px;
      border-top-right-radius: 4px;
      position: relative;
      height: 100%;
    }
  }

  &__content {
    max-width: 540px;
    text-align: center;
    padding: 22px;
    border: 1px solid #333;
    border-top: none;
    border-bottom-left-radius: 4px;
    border-bottom-right-radius: 4px;
  }

  &__text {
    padding-bottom: $spacing-24;
    margin-bottom: $spacing-24;
    border-bottom: 1px solid #333;
  }
}
</style>
